/*---------------+---------------------------------------------------------------+--------------+
                 | Author: Daniel Porumbel 2018       daniel.porumbel@cnam.fr    |
                 |License: Creative Commons Attribution 3.0 Unported License     |
                 |         http://creativecommons.org/licenses/by/3.0/           |             
                 +--------------------------------------------------------------*/
#ifndef BENDERS_H_INCLUDED
#define BENDERS_H_INCLUDED
#define EPSILON 1.0e-6
#define INFEASIBLE -1
extern int ** g;
extern int ** gEdge;//the edge id of each pair of vertices
extern int n;       //number of vertices
extern int m;       //number of edges
extern int*ii;      //ii[i] is the first end vertex of edge i
extern int*jj;      //jj[i] is the second end vertex of edge i
extern double*  b;  //the demands

void    fillConnCompUpToDepth(int* connComp, double* y, int currentVtx, int depth);
int     newCutSet(int* connected, double *cutEdges, double & bSinks);
void    newCut(double * yyy, double *u, double&rightHand);

double newProjection(double* xbase, double * d, double *u, double&rightHand, int checkHitPoint);
double newProjection(double* xbase, double * d, double *u, double&rightHand);

#endif
