/*---------------+---------------------------------------------------------------+--------------+
                 | Author: Daniel Porumbel 2018       daniel.porumbel@cnam.fr    |
                 |License: Creative Commons Attribution 3.0 Unported License     |
                 |         http://creativecommons.org/licenses/by/3.0/           |             
                 +--------------------------------------------------------------*/
#ifndef IIOGRAPHS_INCLUDED
#define IIOGRAPHS_INCLUDED
#include <iostream>
#include <climits>
#include <cmath>
#include <cstdlib>

extern double*b;                      //demands
extern int ** g;
extern int ** gEdge;
extern int n;       //number of vertices
extern int m;       //number of edges
extern int*ii;      //ii[i] is the first end vertex of edge i
extern int*jj;      //jj[i] is the second end vertex of edge i

#define KNOWNCLASSES 7
extern int  graphClass;
extern char graphClassName[20];    //an id of 3 letters
extern int  minId[KNOWNCLASSES]                 ;//see iographs.cpp for values
extern int  maxId[KNOWNCLASSES]                 ;
extern char allGraphClassNames[KNOWNCLASSES][20];
extern double  bMaxDemand[KNOWNCLASSES]         ;
extern double bMaxDemandFromCmdLine             ;//using option -dABC changes (override) the max demand to int ABC
extern int  idThisInstance;//the number of the instance (used by srand as well)
extern char instanceName[100];
extern char* labelGraph;

char* getGraphLabelForStats();
void initDemands();
void initDemands(int divFact);
void initDemands(int divFact, int no_vtx_ser_demand);
void saveGraph(char* filename);
void loadGraph();//random
void loadGraph(char* filename);
void loadGraphFromFile(char* filename);
void genRndGraphAndDemandsOrLoadFromAssocFileWhenItExists(int rndSeed);
double getBandwidth();
void setBandwidth(double);
#endif


