/*---------------+---------------------------------------------------------------+--------------+
                 | Author: Daniel Porumbel 2018       daniel.porumbel@cnam.fr    |
                 |License: Creative Commons Attribution 3.0 Unported License     |
                 |         http://creativecommons.org/licenses/by/3.0/           |             
                 +--------------------------------------------------------------*/
#ifndef MULTI_RUNS_H
#define MULTI_RUNS_H
#include <fstream>
using namespace std;

int    texoutOpen();
void   lineBoxForLastRun(ostream&localout);
void   latexLineForLastRun(ostream&localout);
void   addToStats();
void   printStats();

/*-----------------------+------------------------------------+--------------------------
                         |              PRIVATE               |
                         +-----------------------------------*/

/*Instance data */
extern int      n;                        //number of vertices
extern int      m;                        //number of edges
extern double*  b;                        //the demands
extern char*    solution_method_code;     //the alg (with which options) that is run
/*Data about the performed runs*/
extern double   bestUb ;
extern int      itersCutPlanes;           //these will be filled by cutPlanes.runCutPlanes(...)
extern double   tmCutPlanes, finalObj ;
extern double   totCuts, tmOnlySolve;
extern int      gap20It      ;            //the time and iteration when it reaches a ub/lb gap of 20%
extern double   gap20Tm      ;
extern long     totalNrCoefs ;
extern int      runId        ;
extern int      failedRuns   ;            //This should remain at zero. Otherwise, an error is printed.
/*Loging streams*/
extern char*    texoutfile ;              //When doing several runs, all individual run output can be saved in texoutfile
extern ofstream texout;
/*std method stabilization i.e. smoothing data*/
extern int     smoothedCuts             ;
extern int     twoCutsUsedSmoothedSep ;

#endif

